// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Automation.Models
{
    /// <summary>
    /// Definition of the connection fields.
    /// </summary>
    public partial class FieldDefinition
    {
        private bool _isEncrypted;
        
        /// <summary>
        /// Optional. Gets or sets the isEncrypted flag of the connection field
        /// definition.
        /// </summary>
        public bool IsEncrypted
        {
            get { return this._isEncrypted; }
            set { this._isEncrypted = value; }
        }
        
        private bool _isOptional;
        
        /// <summary>
        /// Optional. Gets or sets the isOptional flag of the connection field
        /// definition.
        /// </summary>
        public bool IsOptional
        {
            get { return this._isOptional; }
            set { this._isOptional = value; }
        }
        
        private string _type;
        
        /// <summary>
        /// Required. Gets or sets the type of the connection field definition.
        /// </summary>
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the FieldDefinition class.
        /// </summary>
        public FieldDefinition()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the FieldDefinition class with
        /// required arguments.
        /// </summary>
        public FieldDefinition(string type)
            : this()
        {
            if (type == null)
            {
                throw new ArgumentNullException("type");
            }
            this.Type = type;
        }
    }
}
