// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// A copy activity Document Database Collection sink.
    /// </summary>
    public partial class DocumentDbCollectionSink : CopySink
    {
        private string _nestingSeparator;
        
        /// <summary>
        /// Optional. Gets or sets nested properties separator.
        /// </summary>
        public string NestingSeparator
        {
            get { return this._nestingSeparator; }
            set { this._nestingSeparator = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DocumentDbCollectionSink class.
        /// </summary>
        public DocumentDbCollectionSink()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the DocumentDbCollectionSink class
        /// with required arguments.
        /// </summary>
        public DocumentDbCollectionSink(int writeBatchSize, TimeSpan writeBatchTimeout)
            : this()
        {
            this.WriteBatchSize = writeBatchSize;
            this.WriteBatchTimeout = writeBatchTimeout;
        }
    }
}
