// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Insights.Models;

namespace Microsoft.Azure.Insights.Models
{
    /// <summary>
    /// Usage Metric data.
    /// </summary>
    public partial class UsageMetric
    {
        private double _currentValue;
        
        /// <summary>
        /// Optional. The current value for the usage metric.
        /// </summary>
        public double CurrentValue
        {
            get { return this._currentValue; }
            set { this._currentValue = value; }
        }
        
        private double _limit;
        
        /// <summary>
        /// Optional. The quota limit the usage metric.
        /// </summary>
        public double Limit
        {
            get { return this._limit; }
            set { this._limit = value; }
        }
        
        private LocalizableString _name;
        
        /// <summary>
        /// Optional. Get the usage metric name and display name.
        /// </summary>
        public LocalizableString Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _nextResetTime;
        
        /// <summary>
        /// Optional. When the current value gets reset.
        /// </summary>
        public string NextResetTime
        {
            get { return this._nextResetTime; }
            set { this._nextResetTime = value; }
        }
        
        private System.TimeSpan? _quotaPeriod;
        
        /// <summary>
        /// Optional. The amount of time it takes to reset the value.
        /// </summary>
        public System.TimeSpan? QuotaPeriod
        {
            get { return this._quotaPeriod; }
            set { this._quotaPeriod = value; }
        }
        
        private string _unit;
        
        /// <summary>
        /// Optional. The unit for the usage metric.
        /// </summary>
        public string Unit
        {
            get { return this._unit; }
            set { this._unit = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the UsageMetric class.
        /// </summary>
        public UsageMetric()
        {
        }
    }
}
