// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure;
using Microsoft.Azure.Management.Insights;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights
{
    public static partial class AutomatedExportOperationsExtensions
    {
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutomatedExportOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource group name.
        /// </param>
        /// <param name='serverName'>
        /// Required. The server name.
        /// </param>
        /// <param name='databaseName'>
        /// Required. The database name.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters supplied to the operation.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static AzureOperationResponse CreateOrUpdateSetting(this IAutomatedExportOperations operations, string resourceGroupName, string serverName, string databaseName, AutomatedExportSettingCreateOrUpdateParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IAutomatedExportOperations)s).CreateOrUpdateSettingAsync(resourceGroupName, serverName, databaseName, parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutomatedExportOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource group name.
        /// </param>
        /// <param name='serverName'>
        /// Required. The server name.
        /// </param>
        /// <param name='databaseName'>
        /// Required. The database name.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters supplied to the operation.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<AzureOperationResponse> CreateOrUpdateSettingAsync(this IAutomatedExportOperations operations, string resourceGroupName, string serverName, string databaseName, AutomatedExportSettingCreateOrUpdateParameters parameters)
        {
            return operations.CreateOrUpdateSettingAsync(resourceGroupName, serverName, databaseName, parameters, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutomatedExportOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='serverName'>
        /// Required. The server name.
        /// </param>
        /// <param name='databaseName'>
        /// Required. The database name.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static AzureOperationResponse DeleteSetting(this IAutomatedExportOperations operations, string resourceGroupName, string serverName, string databaseName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IAutomatedExportOperations)s).DeleteSettingAsync(resourceGroupName, serverName, databaseName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutomatedExportOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='serverName'>
        /// Required. The server name.
        /// </param>
        /// <param name='databaseName'>
        /// Required. The database name.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<AzureOperationResponse> DeleteSettingAsync(this IAutomatedExportOperations operations, string resourceGroupName, string serverName, string databaseName)
        {
            return operations.DeleteSettingAsync(resourceGroupName, serverName, databaseName, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutomatedExportOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='serverName'>
        /// Required. The server name.
        /// </param>
        /// <param name='databaseName'>
        /// Required. The database name.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static AutomatedExportSettingGetResponse GetSetting(this IAutomatedExportOperations operations, string resourceGroupName, string serverName, string databaseName)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IAutomatedExportOperations)s).GetSettingAsync(resourceGroupName, serverName, databaseName);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutomatedExportOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='serverName'>
        /// Required. The server name.
        /// </param>
        /// <param name='databaseName'>
        /// Required. The database name.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<AutomatedExportSettingGetResponse> GetSettingAsync(this IAutomatedExportOperations operations, string resourceGroupName, string serverName, string databaseName)
        {
            return operations.GetSettingAsync(resourceGroupName, serverName, databaseName, CancellationToken.None);
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutomatedExportOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='serverName'>
        /// Required. The server name.
        /// </param>
        /// <param name='databaseName'>
        /// Required. The database name.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters supplied to the operation.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static AzureOperationResponse UpdateSetting(this IAutomatedExportOperations operations, string resourceGroupName, string serverName, string databaseName, AutomatedExportSettingCreateOrUpdateParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IAutomatedExportOperations)s).UpdateSettingAsync(resourceGroupName, serverName, databaseName, parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Insights.IAutomatedExportOperations.
        /// </param>
        /// <param name='resourceGroupName'>
        /// Required. The resource name.
        /// </param>
        /// <param name='serverName'>
        /// Required. The server name.
        /// </param>
        /// <param name='databaseName'>
        /// Required. The database name.
        /// </param>
        /// <param name='parameters'>
        /// Required. Parameters supplied to the operation.
        /// </param>
        /// <returns>
        /// A standard service response including an HTTP status code and
        /// request ID.
        /// </returns>
        public static Task<AzureOperationResponse> UpdateSettingAsync(this IAutomatedExportOperations operations, string resourceGroupName, string serverName, string databaseName, AutomatedExportSettingCreateOrUpdateParameters parameters)
        {
            return operations.UpdateSettingAsync(resourceGroupName, serverName, databaseName, parameters, CancellationToken.None);
        }
    }
}
