// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents the properties of a Azure SQL Recommended Elastic Pool being
    /// upgraded.
    /// </summary>
    public partial class UpgradeRecommendedElasticPoolProperties
    {
        private IList<string> _databaseCollection;
        
        /// <summary>
        /// Optional. Gets or sets the list of database names to be put in the
        /// Azure SQL Recommended Elastic Pool being upgraded.
        /// </summary>
        public IList<string> DatabaseCollection
        {
            get { return this._databaseCollection; }
            set { this._databaseCollection = value; }
        }
        
        private int _databaseDtuMax;
        
        /// <summary>
        /// Optional. Gets or sets the DTU cap for database for the Azure SQL
        /// Recommended Elastic Pool being upgraded.
        /// </summary>
        public int DatabaseDtuMax
        {
            get { return this._databaseDtuMax; }
            set { this._databaseDtuMax = value; }
        }
        
        private int _databaseDtuMin;
        
        /// <summary>
        /// Optional. Gets or sets the DTU guarantee for database for the Azure
        /// SQL Recommended Elastic Pool being upgraded.
        /// </summary>
        public int DatabaseDtuMin
        {
            get { return this._databaseDtuMin; }
            set { this._databaseDtuMin = value; }
        }
        
        private int _dtu;
        
        /// <summary>
        /// Optional. Gets or sets the DTU guarantee for the Azure SQL
        /// Recommended Elastic Pool being upgraded.
        /// </summary>
        public int Dtu
        {
            get { return this._dtu; }
            set { this._dtu = value; }
        }
        
        private string _edition;
        
        /// <summary>
        /// Optional. Gets or sets the target edition for the Azure SQL
        /// Recommended Elastic Pool being upgraded.
        /// </summary>
        public string Edition
        {
            get { return this._edition; }
            set { this._edition = value; }
        }
        
        private bool? _includeAllDatabases;
        
        /// <summary>
        /// Optional. Gets or sets whether all databases to be put in the Azure
        /// SQL Recommended Elastic Pool being upgraded.
        /// </summary>
        public bool? IncludeAllDatabases
        {
            get { return this._includeAllDatabases; }
            set { this._includeAllDatabases = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the name of the Azure SQL Recommended
        /// Elastic Pool being upgraded.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private int _storageMb;
        
        /// <summary>
        /// Optional. Gets or sets the storage limit in MB for the Azure SQL
        /// Recommended Elastic Pool being upgraded.
        /// </summary>
        public int StorageMb
        {
            get { return this._storageMb; }
            set { this._storageMb = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// UpgradeRecommendedElasticPoolProperties class.
        /// </summary>
        public UpgradeRecommendedElasticPoolProperties()
        {
            this.DatabaseCollection = new LazyList<string>();
        }
    }
}
