// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Defines a data deletion detection policy that implements a
    /// soft-deletion strategy. It determines whether an item should be
    /// deleted based on the value of a designated 'soft delete' column.
    /// </summary>
    [JsonObject("#Microsoft.Azure.Search.SoftDeleteColumnDeletionDetectionPolicy")]
    public partial class SoftDeleteColumnDeletionDetectionPolicy : DataDeletionDetectionPolicy
    {
        /// <summary>
        /// Initializes a new instance of the
        /// SoftDeleteColumnDeletionDetectionPolicy class.
        /// </summary>
        public SoftDeleteColumnDeletionDetectionPolicy() { }

        /// <summary>
        /// Initializes a new instance of the
        /// SoftDeleteColumnDeletionDetectionPolicy class.
        /// </summary>
        public SoftDeleteColumnDeletionDetectionPolicy(string softDeleteColumnName = default(string), string softDeleteMarkerValue = default(string))
        {
            SoftDeleteColumnName = softDeleteColumnName;
            SoftDeleteMarkerValue = softDeleteMarkerValue;
        }

        /// <summary>
        /// Gets or sets the name of the column to use for soft-deletion
        /// detection.
        /// </summary>
        [JsonProperty(PropertyName = "softDeleteColumnName")]
        public string SoftDeleteColumnName { get; set; }

        /// <summary>
        /// Gets or sets the marker value that indentifies an item as deleted.
        /// </summary>
        [JsonProperty(PropertyName = "softDeleteMarkerValue")]
        public string SoftDeleteMarkerValue { get; set; }

    }
}
