// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Provides parameter values to a tag scoring function.
    /// </summary>
    public partial class TagScoringParameters
    {
        /// <summary>
        /// Initializes a new instance of the TagScoringParameters class.
        /// </summary>
        public TagScoringParameters() { }

        /// <summary>
        /// Initializes a new instance of the TagScoringParameters class.
        /// </summary>
        public TagScoringParameters(string tagsParameter)
        {
            TagsParameter = tagsParameter;
        }

        /// <summary>
        /// Gets or sets the name of the parameter passed in search queries to
        /// specify the list of tags to compare against the target field.
        /// </summary>
        [JsonProperty(PropertyName = "tagsParameter")]
        public string TagsParameter { get; set; }

        /// <summary>
        /// Validate the object. Throws ArgumentException or ArgumentNullException if validation fails.
        /// </summary>
        public virtual void Validate()
        {
            if (TagsParameter == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "TagsParameter");
            }
        }
    }
}
