// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Properties that describe an Azure Search service.
    /// </summary>
    public partial class SearchServiceCreateOrUpdateParameters
    {
        /// <summary>
        /// Initializes a new instance of the
        /// SearchServiceCreateOrUpdateParameters class.
        /// </summary>
        public SearchServiceCreateOrUpdateParameters() { }

        /// <summary>
        /// Initializes a new instance of the
        /// SearchServiceCreateOrUpdateParameters class.
        /// </summary>
        public SearchServiceCreateOrUpdateParameters(string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), SearchServiceProperties properties = default(SearchServiceProperties))
        {
            Location = location;
            Tags = tags;
            Properties = properties;
        }

        /// <summary>
        /// Gets or sets the geographic location of the Search service.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets tags to help categorize the Search service in the
        /// Azure Portal.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Gets or sets properties of the Search service.
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public SearchServiceProperties Properties { get; set; }

    }
}
