// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.Compute.Models;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// The market place image attributes.
    /// </summary>
    public partial class MarketplaceImageAttributes
    {
        private Plan _plan;
        
        /// <summary>
        /// Required. Gets or sets the purchase context of any 3rd party
        /// artifact.
        /// </summary>
        public Plan Plan
        {
            get { return this._plan; }
            set { this._plan = value; }
        }
        
        private string _publisherId;
        
        /// <summary>
        /// Required. Gets or sets the publisher Id. This is the
        /// Microsoft.Compute Provider publisher name to use for image.
        /// </summary>
        public string PublisherId
        {
            get { return this._publisherId; }
            set { this._publisherId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the MarketplaceImageAttributes class.
        /// </summary>
        public MarketplaceImageAttributes()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the MarketplaceImageAttributes class
        /// with required arguments.
        /// </summary>
        public MarketplaceImageAttributes(string publisherId, Plan plan)
            : this()
        {
            if (publisherId == null)
            {
                throw new ArgumentNullException("publisherId");
            }
            if (plan == null)
            {
                throw new ArgumentNullException("plan");
            }
            this.PublisherId = publisherId;
            this.Plan = plan;
        }
    }
}
