// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.RemoteApp.Models
{
    /// <summary>
    /// Contains details of a billing plan.
    /// </summary>
    public partial class BillingPlan
    {
        private string _addOns;
        
        /// <summary>
        /// Optional. Associated add-ons.
        /// </summary>
        public string AddOns
        {
            get { return this._addOns; }
            set { this._addOns = value; }
        }
        
        private double _coresPerUser;
        
        /// <summary>
        /// Optional. Computing cores per user.
        /// </summary>
        public double CoresPerUser
        {
            get { return this._coresPerUser; }
            set { this._coresPerUser = value; }
        }
        
        private string _id;
        
        /// <summary>
        /// Optional. Unique identifier of billing plan.
        /// </summary>
        public string Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private int _minimumBilledUserCount;
        
        /// <summary>
        /// Optional. Minimum number of user to bill.
        /// </summary>
        public int MinimumBilledUserCount
        {
            get { return this._minimumBilledUserCount; }
            set { this._minimumBilledUserCount = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Short name of billing plan.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the BillingPlan class.
        /// </summary>
        public BillingPlan()
        {
        }
    }
}
