// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.RemoteApp.Models
{
    /// <summary>
    /// The security principal resolution error codes.
    /// </summary>
    public enum SecurityPrincipalOperationError
    {
        /// <summary>
        /// The security principal could not be resolved.
        /// </summary>
        CouldNotBeResolved = 0,
        
        /// <summary>
        /// The security principal is missing from the requested collection.
        /// </summary>
        NotFound = 1,
        
        /// <summary>
        /// The security principal already exists in the requested collection.
        /// </summary>
        AlreadyExists = 2,
        
        /// <summary>
        /// The security principal is not supported for this type of collection.
        /// </summary>
        NotSupported = 3,
        
        /// <summary>
        /// The security principal is not synchronized with Azure
        /// ActiveDirectory.
        /// </summary>
        NotDirsynced = 4,
        
        /// <summary>
        /// The security principal is not allowed in more than one collection.
        /// </summary>
        AssignedToAnotherCollection = 5,
    }
}
