// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.SiteRecovery.Models;

namespace Microsoft.WindowsAzure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The response model for the list networks operation.
    /// </summary>
    public partial class NetworkListResponse : AzureOperationResponse, IEnumerable<Network>
    {
        private IList<Network> _networks;
        
        /// <summary>
        /// Optional. The list of networks for the given vault.
        /// </summary>
        public IList<Network> Networks
        {
            get { return this._networks; }
            set { this._networks = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the NetworkListResponse class.
        /// </summary>
        public NetworkListResponse()
        {
            this.Networks = new LazyList<Network>();
        }
        
        /// <summary>
        /// Gets the sequence of Networks.
        /// </summary>
        public IEnumerator<Network> GetEnumerator()
        {
            return this.Networks.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of Networks.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
