// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Sql.Models
{
    /// <summary>
    /// Represents the parameters supplied to the Get Database Event Logs
    /// operation.
    /// </summary>
    public partial class DatabaseGetEventLogsParameters
    {
        private string _eventTypes;
        
        /// <summary>
        /// Required. Gets or sets the event types to retrieve.
        /// </summary>
        public string EventTypes
        {
            get { return this._eventTypes; }
            set { this._eventTypes = value; }
        }
        
        private int _intervalSizeInMinutes;
        
        /// <summary>
        /// Required. Gets or sets the interval size in minutes.
        /// </summary>
        public int IntervalSizeInMinutes
        {
            get { return this._intervalSizeInMinutes; }
            set { this._intervalSizeInMinutes = value; }
        }
        
        private DateTime _startDate;
        
        /// <summary>
        /// Required. Gets or sets the start date for the event log.
        /// </summary>
        public DateTime StartDate
        {
            get { return this._startDate; }
            set { this._startDate = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DatabaseGetEventLogsParameters
        /// class.
        /// </summary>
        public DatabaseGetEventLogsParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the DatabaseGetEventLogsParameters
        /// class with required arguments.
        /// </summary>
        public DatabaseGetEventLogsParameters(DateTime startDate, int intervalSizeInMinutes, string eventTypes)
            : this()
        {
            if (eventTypes == null)
            {
                throw new ArgumentNullException("eventTypes");
            }
            this.StartDate = startDate;
            this.IntervalSizeInMinutes = intervalSizeInMinutes;
            this.EventTypes = eventTypes;
        }
    }
}
