// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Data statistics for a DeviceJob
    /// </summary>
    public partial class DataStatistics
    {
        private long _cloudData;
        
        /// <summary>
        /// Optional. Data written to cloud (in Bytes)
        /// </summary>
        public long CloudData
        {
            get { return this._cloudData; }
            set { this._cloudData = value; }
        }
        
        private long _processedData;
        
        /// <summary>
        /// Optional. Data processed (in Bytes)
        /// </summary>
        public long ProcessedData
        {
            get { return this._processedData; }
            set { this._processedData = value; }
        }
        
        private long _throughput;
        
        /// <summary>
        /// Optional. Average throughput (in Bytes/sec)
        /// </summary>
        public long Throughput
        {
            get { return this._throughput; }
            set { this._throughput = value; }
        }
        
        private long _totalData;
        
        /// <summary>
        /// Optional. Total data (in Bytes)
        /// </summary>
        public long TotalData
        {
            get { return this._totalData; }
            set { this._totalData = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DataStatistics class.
        /// </summary>
        public DataStatistics()
        {
        }
    }
}
