// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Job status information
    /// </summary>
    public partial class JobStatusInfo
    {
        private CisApiError _error;
        
        /// <summary>
        /// Required. Error details
        /// </summary>
        public CisApiError Error
        {
            get { return this._error; }
            set { this._error = value; }
        }
        
        private string _jobId;
        
        /// <summary>
        /// Required. Unique Id of Job
        /// </summary>
        public string JobId
        {
            get { return this._jobId; }
            set { this._jobId = value; }
        }
        
        private IList<JobStep> _jobSteps;
        
        /// <summary>
        /// Required. Job Steps
        /// </summary>
        public IList<JobStep> JobSteps
        {
            get { return this._jobSteps; }
            set { this._jobSteps = value; }
        }
        
        private JobResult _result;
        
        /// <summary>
        /// Required. Result
        /// </summary>
        public JobResult Result
        {
            get { return this._result; }
            set { this._result = value; }
        }
        
        private JobStatus _status;
        
        /// <summary>
        /// Required. Job status
        /// </summary>
        public JobStatus Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        private TaskResult _taskResult;
        
        /// <summary>
        /// Required. Task Result
        /// </summary>
        public TaskResult TaskResult
        {
            get { return this._taskResult; }
            set { this._taskResult = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobStatusInfo class.
        /// </summary>
        public JobStatusInfo()
        {
            this.JobSteps = new LazyList<JobStep>();
        }
    }
}
